"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

Object subclass:#C1CompilerBackend
	instanceVariableNames:''
	classVariableNames:'SelectorSpecialCharMappingTable'
	poolDictionaries:''
	category:'DragonFly-C1'
!

!C1CompilerBackend class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1CompilerBackend class methodsFor:'instance creation'!

new
    | cpu |

    self ~~ C1CompilerBackend ifTrue:[
        ^ super new.
    ].
    cpu := OperatingSystem getCPUType.
    cpu == #'x86_64' ifTrue:[
        ^ C1CompilerBackendX86_64 new
    ].
    self error:'Unsupported architecture: ' , cpu

    "Created: / 24-07-2016 / 23:26:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1CompilerBackend class methodsFor:'class initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    "/ please change as required (and remove this comment)

    SelectorSpecialCharMappingTable := Dictionary withKeysAndValues:
                #($+ 'pl'
                  $- 'mi'
                  $* 'mu'
                  $/ 'di'
                  $, 'co'
                  $@ 'at'
                  $< 'le'
                  $> 'gr'
                  $= 'eq'
                  $~ 'ne'
                  $| 'pi'
                  $\ 'mo'
                  $& 'am').

    "Created: / 09-02-2016 / 08:43:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 26-08-2016 / 14:21:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1CompilerBackend class methodsFor:'utilities'!

functionNameForClass: class selector: selector      
    "For given class name and selector, returns the name 
     used by LLVM"

    ^ String streamContents:[ :s|
        s nextPutAll: '__M_D_'.
        s nextPutAll: (class name copyReplaceAll: $: with: $_).
        s nextPut: $_.
        selector isBinarySelector ifTrue:[ 
            selector do:[:c |     
                s nextPutAll: (SelectorSpecialCharMappingTable at: c)
            ].
        ] ifFalse:[ 
            selector do:[:c |  
                c isAlphaNumeric ifTrue:[ 
                    s nextPut: c 
                ] ifFalse:[
                    s nextPut: $_.
                    c == $: ifFalse:[ 
                        c codePoint printOn: s.
                    ]
                ].
            ]
        ].
    ].

    "
    C1Compiler functionNameForClass: C1Compiler selector: #functionNameForClass:selector: 
    C1Compiler functionNameForClass: SmallInteger selector: #+
    C1Compiler functionNameForClass: Object selector: #~=
    C1Compiler functionNameForClass: JavaVM selector: #_ALOAD:

    "

    "Created: / 09-02-2016 / 08:44:10 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !


C1CompilerBackend initialize!
