"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:dragonfly/c1' }"

"{ NameSpace: DragonFly }"

C1NumericValue subclass:#C1IntegerValue
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:'LLVMIntPredicate'
	category:'DragonFly-C1'
!

!C1IntegerValue class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2016-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.

"
! !

!C1IntegerValue class methodsFor:'testing'!

isAbstract
    ^ self == DragonFly::C1IntegerValue
! !

!C1IntegerValue methodsFor:'accessing'!

objValue
    "Return LLVMValue representing an Smalltalk object"
    
    (objValue isNil and:[numValue notNil]) ifTrue:[ 
        objValue := self objValueFromNumValue: numValue.
        ^ objValue.
    ].
    ^ super objValue.

    "Created: / 06-08-2016 / 18:23:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1IntegerValue methodsFor:'comparing'!

< aC1ValueOrInteger
    ^ self cmp: LLVMIntSLT with: aC1ValueOrInteger

    "Created: / 17-08-2016 / 22:38:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 19-08-2016 / 23:32:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

<= aC1ValueOrInteger
    ^ self cmp: LLVMIntSLE with: aC1ValueOrInteger

    "Created: / 15-08-2016 / 23:19:06 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 19-08-2016 / 23:32:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

= aC1ValueOrInteger
    ^ self cmp: LLVMIntEQ with: aC1ValueOrInteger

    "Created: / 17-08-2016 / 22:38:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 19-08-2016 / 23:32:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

> aC1ValueOrInteger
    ^ self cmp: LLVMIntSGT with: aC1ValueOrInteger

    "Created: / 17-08-2016 / 22:38:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 19-08-2016 / 23:32:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

>= aC1ValueOrInteger
    ^ self cmp: LLVMIntSGE with: aC1ValueOrInteger

    "Created: / 16-08-2016 / 08:33:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 19-08-2016 / 23:32:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

~= aC1ValueOrInteger
    ^ self cmp: LLVMIntNE with: aC1ValueOrInteger

    "Created: / 17-08-2016 / 22:38:55 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 19-08-2016 / 23:32:34 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1IntegerValue methodsFor:'private'!

cmp: predicate with: valueOrInteger
    | another resultVal |

    valueOrInteger isInteger ifTrue:[ 
        another := valueOrInteger asC1Int32Value.
    ] ifFalse:[ 
        self assert: valueOrInteger class == self class.
        another := valueOrInteger.
    ].

    resultVal := backend emitICmp: self numValue with: another numValue predicate: predicate.
    ^ (C1Value bool: resultVal) 
        setBackend: backend;
        yourself

    "Created: / 15-08-2016 / 23:23:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 22-08-2016 / 10:29:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numValueFromConstant:anInteger 
    self assert:anInteger isInteger.
    self 
        assert:(anInteger between:self numValueMinVal and: self numValueMaxVal).
    ^ LLVMConstant sint:anInteger type:self numType

    "Created: / 06-08-2016 / 09:02:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-08-2016 / 18:15:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numValueMaxVal
    ^ self subclassResponsibility

    "Created: / 06-08-2016 / 09:02:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

numValueMinVal
    ^ self subclassResponsibility

    "Created: / 06-08-2016 / 09:02:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

objValueFromNumValue: numVal
    ^ backend makeInteger32: numVal.

    "Created: / 06-08-2016 / 09:28:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 06-08-2016 / 18:33:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!C1IntegerValue class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

